#!/usr/bin/env python
import sys;
import base64;
from suds.client import Client;
from suds import WebFault;
flux=Client('http://13cflux.net/FluxWS/Flux?wsdl');
params=flux.factory.create('ns1:parameter');

tas=len(sys.argv);
#print tas;
h=0;
k=0;
l=0;
input2=0;
output=0;
if (len(sys.argv) > 1 ):
 for i in range(1,len(sys.argv)):
  if (sys.argv[i]=="-h"):
   print "*** This version of 15CFLUX 2 is licensed to: \n*** Demo Version, FZ Juelich \nForward Simulation (c) 2009,2010 Michael Weitzel \nSyntax: fwdsim <parameters>: \nIn this demo version only one outputfile per call is possible:\n  -i/--in <inputfile>	        FluxML input file (stdin if omitted)\n  -o/--out <outputfile>         name of FWDSIM (XML) output file (stdout if omitted)\n  -H/--hdf5 <outputfile>        export stoichiometry and the cascade's numerical systems\n                                into a HDF5 file (if -s is passed, Jacobian of\n                      	        measurements and covariance matrix are exported as well)\n                       	        the covariance matrix) into a HDF5 file\n  -M/--mathml <outputfile>      export the cascade's symbolic systems into a MathML file\n  -T/--text <outputfile>        export the cascade's symbolic systems into a text file\n  -m/--matlab <outputfile>      generate a network simulator as MATLAB script\n  -a/--apsolve         		simulate the network using an arbitrary precision solver\n  -A/--exact          		perform a full analytic solution (incl. measurements)\n  -t/--tolerance <val>          double value; tolerance for constraint violation\n  -s/--statistics               compute linearized statistical analysis"
   h=1;
   # if h==0:
   # for i in range(1,len(sys.argv)):
   #      if (i=="-o"):
   #	 peter=1;
   #	 file=sys.argv[i+1]
 if (h==0):
  for i in range(1,len(sys.argv)):	
   if (sys.argv[i]=="-i"):
    input2=sys.argv[i+1]
    k=1;
   if (sys.argv[i]=="-o"):
    output=sys.argv[i+1]
    l=1;
   if (sys.argv[i]=="-a"):
    params.fwdsim.apsolve=True;
   if (sys.argv[i]=="-A"):
    params.fwdsim.exact=True;
   if (sys.argv[i]=="-s"):
    params.fwdsim.statistics=True;
   if (sys.argv[i]=="-t"):
    params.fwdsim.tolerance=float(sys.argv[i+1]);
  if (l==0):
   for i in range(1,len(sys.argv)):
    if (sys.argv[i]=="-H"):
     output=sys.argv[i+1];
     params.fwdsim.hdf5=True;
     l=1
  if (l==0):
   for i in range(1,len(sys.argv)):
    if (sys.argv[i]=="-T"):
     output=sys.argv[i+1];
     params.fwdsim.text=True;
     l=1
  if (l==0):
   for i in range(1,len(sys.argv)):
    if (sys.argv[i]=="-M"):
     output=sys.argv[i+1];
     params.fwdsim.mathml=True;
     l=1
  if (l==0):
   for i in range(1,len(sys.argv)):
    if (sys.argv[i]=="-m"):
     output=sys.argv[i+1];
     params.fwdsim.matlab=True;
     l=1
  if (k==1):
   if (l==1):
    fml_f = open(input2, 'rb');
    fml   = base64.b64encode(fml_f.read());
    fml_f.close();
    try:
     res=flux.service.FWDSIM(fml,params);
    except WebFault, e:
    	print 'Failed to invoke web service:';
    	print e.fault.faultstring;
    	exit(1); 
    p=open(output, 'wb')
    p.write(base64.b64decode(res))
    p.close()
   if (l==0): #& k==1):
    fml_f = open(input2, 'rb');
    fml   = base64.b64encode(fml_f.read());
    fml_f.close();
    try:
     res=flux.service.FWDSIM(fml,params);
    except WebFault, e:
    	print 'Failed to invoke web service:';
    	print e.fault.faultstring;
    	exit(1);
    print base64.b64decode(res)
  if (k==0):
   print "You have to specify an input file"
else:
 print "You have to specify an input file"
